Attribute VB_Name = "GoodArch"
Option Explicit
Option Base 1

Public Type ARCH_DATA_ENTRY
    Key             As String
    Quantity        As Long
    '
    '    
    '
End Type

Public Type ARCH_TREE_NODE
    ChildrenIndecies()    As Long
    OwnDataEntryIndex     As Long
End Type

Public Type ARCH_TREE_OBJECT
    lMaxDepth   As Long
    cNodes      As Long
    cEntries    As Long
    Nodes()     As ARCH_TREE_NODE
    Entries()   As ARCH_DATA_ENTRY
End Type

Public Type ARCH_TREE_ITERATOR
    Nesting     As Long
    
End Type


Public Sub EntryTreeInit(ByRef tree As ARCH_TREE_OBJECT)
    tree.cNodes = 1
    ReDim tree.Nodes(1 To 1)
    
    tree.cEntries = 0
    Erase tree.Entries
End Sub

Public Function EntryTreeIteratorInit(ByRef tree As ARCH_TREE_OBJECT, _
                                      ByRef iter As ARCH_TREE_ITERATOR) As Long
                                     
End Function


Public Function EntryTreeAddOrGet(ByRef tree As ARCH_TREE_OBJECT, _
                                  ByVal index As Long) As Long
                                  
    Dim sIndexInternal As String
    
    sIndexInternal = CStr(index)
    
    Dim PathElms() As Byte
    Dim cPathElms  As Long
    Dim iPathElm   As Long
    
    InitPathElms sIndexInternal, PathElms, cPathElms
    
    Dim iCurNode   As Long
    Dim iNextNode  As Long
    
    Dim iDepth     As Long
    
    iCurNode = 1 '    
    With tree
        Do
            On Error GoTo AllocateChildrenList
            iNextNode = .Nodes(iCurNode).ChildrenIndecies(PathElms(iPathElm))
            On Error GoTo 0
            
            If iNextNode = 0 Then
                iNextNode = EntryTreeAllocateNode(tree, iCurNode, PathElms(iPathElm))
            End If
            
            iCurNode = iNextNode
            
            iPathElm = iPathElm + 1
            
            iDepth = iDepth + 1
        Loop Until iPathElm = cPathElms
        
        If .lMaxDepth < iDepth Then .lMaxDepth = iDepth
        
        If .Nodes(iCurNode).OwnDataEntryIndex <> 0 Then
            EntryTreeAddOrGet = .Nodes(iCurNode).OwnDataEntryIndex
        Else
        
            '
            '    . .
            '
            
            EntryTreeAddOrGet = EntryTreeAllocateEntry(tree, iCurNode, sIndexInternal)
            
        End If
        
        
        
    End With
    
    
    Exit Function
AllocateChildrenList:
    ReDim tree.Nodes(iCurNode).ChildrenIndecies(0 To 9)
    Resume
End Function

Private Function EntryTreeAllocateNode(ByRef tree As ARCH_TREE_OBJECT, _
                                       ByRef iParentNode As Long, _
                                       ByVal iLinkIndex As Byte) As Long
    Dim iNewNode As Long
    iNewNode = tree.cNodes + 1
    
    ReDim Preserve tree.Nodes(1 To iNewNode)
    tree.cNodes = tree.cNodes + 1
    
    tree.Nodes(iParentNode).ChildrenIndecies(iLinkIndex) = iNewNode
    
    EntryTreeAllocateNode = iNewNode
End Function
                                  
Private Function EntryTreeAllocateEntry(ByRef tree As ARCH_TREE_OBJECT, _
                                       ByRef iNode As Long, _
                                       ByRef index As String) As Long
    Dim iNewEntry As Long
    iNewEntry = tree.cEntries + 1
    tree.cEntries = tree.cEntries + 1
    
    ReDim Preserve tree.Entries(1 To iNewEntry)
    tree.Entries(iNewEntry).Key = index
    
    tree.cEntries = iNewEntry
    
    tree.Nodes(iNode).OwnDataEntryIndex = iNewEntry
    EntryTreeAllocateEntry = iNewEntry
End Function
                                  

Private Sub InitPathElms(ByVal index As String, ByRef aryElms() As Byte, ByRef count As Long)
    Const DIGIT_BASE = 48 ' = Asc("0")
    count = Len(index)
    ReDim aryElms(0 To count - 1)
    
    
    Dim i As Long
    
    For i = 0 To count - 1
        aryElms(i) = Asc(Mid$(index, i + 1, 1)) - DIGIT_BASE
    Next i
End Sub
